
local timePower = 0
local timeSweep = 0
local timePerSweepCheck = 0.025
local smokeTimer = 0
local CurrentHour = 0
local CurrentMinute = 0
local DoTazerSweep = false
local DoTazerAdjust = false
local AverageDamage = 0
local TotalDamage = 0
local TargetInterval = {}
local TargetMinute = {}
local CoveredArea = {}
local TargetTazed =		 { ["low"] = 5,		 ["medium"] = 25,		 ["high"] = 60,		 ["ultra"] = 62,	 ["insane"] = 65	 }
local BeamIntensity =	 { ["low"] = 2,		 ["medium"] = 3,		 ["high"] = 4,		 ["ultra"] = 6,		 ["insane"] = 6		 }
local DischargePerShot = { ["low"] = 0.25,	 ["medium"] = 0.50,		 ["high"] = 0.75,	 ["ultra"] = 1.25,	 ["insane"] = 5		 }
local TargetDamage =	 { ["low"] = 0.015,	 ["medium"] = 0.033,	 ["high"] = 0.099,	 ["ultra"] = 0.134,	 ["insane"] = 0.85	 }
local SmokeAmount =		 { ["low"] = 1,		 ["medium"] = 2,		 ["high"] = 3,		 ["ultra"] = 4,		 ["insane"] = 5		 }
local AmpereAmount =	 { ["low"] = 1,		 ["medium"] = 2,		 ["high"] = 3,		 ["ultra"] = 4,		 ["insane"] = 5		 }
local Get = Object.GetProperty
local Set = Object.SetProperty
local nearbyPrisoners = {}
local ProcessedPrisoners = 0

function Create()
	Set(this,"HomeUID",me["id-uniqueId"])
	Set(this,"DoRange",15)
	Set(this,"DoAmperage","low")
	Set(this,"DoInterval","low")
	Set(this,"TazerAll",false)
	Set(this,"Ignore",true)
	Set(this,"DoBladder",false)
	Set(this,"DoBowels",false)
	Set(this,"DoDeadly","off")
	Set(this,"DoSmoke",false)
	Set(this,"DoCalm",false)
	Set(this,"DoEnergyBurst",true)
	Set(this,"DoPrisonerBurst",false)
	Set(this,"DoSweep",false)
	TazerRange = Get(this,"DoRange")
	TazerAmperage = Get(this,"DoAmperage")
	TazerInterval = Get(this,"DoInterval")
	TazerDamage = Get(this,"DoDeadly")
	this.Tooltip = {"tooltip_T3TeslaNoPower",this.DoRange,"R"}
	newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
	Set(newPower,"HomeUID",this.HomeUID)
	Set(newPower,"Tooltip","Tesla-Matic Energy Source 1")
	newPower.Hidden = true
end

function Update( timePassed )
	if timePerPowerCheck == nil then
		Set(this,"TimeWarp",World.TimeWarpFactor)
		GetDoorTimer()
		InitAfterSave()
	end
	
	timePower = timePower + timePassed
	if timePower >= timePerPowerCheck then
		timePower = 0
		
		UpdateCountDown()
		
		if not Exists(MyDoorTimer) then GetDoorTimer() end
		if MyDoorTimer.On == true then -- we have high power
		
			if Get(MyDoorTimer,"Time"..CurrentHour) == true then	-- door timer is active during this hour
			
				this.SubType = AmpereAmount[TazerAmperage] + 10		-- turn globe green and show amperage leds
				
				for i=1,#TargetMinute do
					if TargetMinute[i] == CurrentMinute  then
						if DoTazerSweep == false and DoTazerAdjust == false then
							PrepareSweep()
							DoTazerSweep = true
						end
					end
				end
			else													-- door timer is not active during this hour
			
				this.SubType = AmpereAmount[TazerAmperage] + 1		-- turn globe red, keep amperage leds active
				
			end
			
			smokeTimer = smokeTimer + 1								-- clear smoke every 4 ticks if needed
			if smokeTimer >= 4 then
				smokeTimer = 0
				if this.DoSmoke == true then
					ClearSmoke()
				end
			end
			
		else
		
			this.SubType = 1										-- turn globe red and disable amperage leds
			
		end
		
		UpdateTooltip()
	end
	
	timeSweep = timeSweep + timePassed
	if timeSweep >= timePerSweepCheck then
		timeSweep = 0
		if DoTazerAdjust == true then
			if this.SubType == 17 then this.SubType = 16 else this.SubType = 17 end	-- toggle orange and red amperage leds
			DoAdjust()
		end
		if DoTazerSweep == true then
			if this.SubType == 16 then this.SubType = 17 else this.SubType = 16 end
			DoSweep()
		end
		-- you might expect DoSweep() first and then DoAdjust() here...
		-- ...but DoAdjust() has been placed above DoSweep() because otherwise the required little delay explained furtheron wouldn't work
	end
end

function PrepareSweep()
	ProcessedPrisoners = 0
	AverageDamage = 0
	PrisonersToShock = GetObjectsInSquare("Prisoner",TazerRange)
	PrisonersToAdjust = GetObjectsInSquare("Prisoner",TazerRange)
	MySweep = Object.Spawn("TeslaSweep3",this.Pos.x,this.Pos.y-0.5)
	MySweep.HomeUID = this.HomeUID
	MySweep.Intensity = 10
	-- MySweep.Intensity = BeamIntensity[TazerAmperage]
	MySweep.Start = true
	if this.DoEnergyBurst == true then
		MyBurst = Object.Spawn("TeslaEnergyBurst"..this.DoRange,this.Pos.x,this.Pos.y-0.5)
		MyBurst.HomeUID = this.HomeUID
		MyBurst.Intensity = 10
		-- MyBurst.Intensity = BeamIntensity[TazerAmperage]
		MyBurst.Hidden = true
		MyBurst.Start = true
	end
	this.Sound("Tesla-Matic3","Sweep")
end

function DoSweep()
	print("DoSweep")
	if next(PrisonersToShock) then
		for CurrentPrisoner, dist in pairs(PrisonersToShock) do
			if this.TazerAll == false then
				if CurrentPrisoner.Misbehavior == "Spoiling" or CurrentPrisoner.Misbehavior == "Fighting" or CurrentPrisoner.Misbehavior == "Rioting" or CurrentPrisoner.Misbehavior == "Destroying" or CurrentPrisoner.Misbehavior == "Misbehaving" or CurrentPrisoner.Misbehavior == "Escaping" then
					CurrentPrisoner.beTazed = true
				end
			else
				if CurrentPrisoner.Damage == 1 then
					if this.DoSmoke == true and math.random() >= 0.75 then
						for s=1,SmokeAmount[TazerAmperage] do
							Object.Spawn("SmokeGenerator", CurrentPrisoner.Pos.x, CurrentPrisoner.Pos.y)		-- no more tazer shots for him, it's just a smoking dead body
						end
					end
				elseif this.Ignore == true and CurrentPrisoner.Damage == 0 then
					CurrentPrisoner.beTazed = true
				elseif this.Ignore == false and CurrentPrisoner.Damage ~= 1 then
					CurrentPrisoner.beTazed = true			
				end
			end
			if CurrentPrisoner.beTazed == true then
				ProcessedPrisoners = ProcessedPrisoners + 1
				if ProcessedPrisoners > 50 then				-- make it less attractive to mass-tazer everybody in the prison with only one device
					overLoading = math.random()
					if overLoading <= 0.11 then				-- 11% chance the Tesla-Matic will blow up when used on more than 50 prisoners at once.
						this.Sound("Tesla-Matic3","Overload")
						DoOverload()
						return
					end
				end
				
				if not this.PeakCreated then
					CreatePowerPeak()
					if this.DoEnergyBurst == true then
						MyBurst.Hidden = false
					end
					this.PeakCreated = true
				end
				
				if this.DoPrisonerBurst == true then
					PrisonerBurst = Object.Spawn("PrisonerEnergyBurst3",CurrentPrisoner.Pos.x,CurrentPrisoner.Pos.y)
					PrisonerBurst.Slot0.i = CurrentPrisoner.Id.i
					PrisonerBurst.Slot0.u = CurrentPrisoner.Id.u
					PrisonerBurst.Intensity = BeamIntensity[TazerAmperage]
					PrisonerBurst.Start = true
				end
				
				CurrentPrisoner.Sound("_Tools", "HitBy_Tazer")
				if TargetTazed[TazerAmperage] < 60 then
					-- prisonerBurst.TargetTazed = TargetTazed[TazerAmperage]	
					CurrentPrisoner.StatusEffects.tazed = 60				-- let him shake from a real tazer first, then we wait a little bit, and finally we fill in the desired tazed amount during DoAdjust() because any tazed value below 60 won't make him shake.
				else
					CurrentPrisoner.StatusEffects.tazed = TargetTazed[TazerAmperage]
				end
				if TazerDamage ~= "off" then								--> trivia: ~= "off" is something different than == "on" (which value does not exist)
					if TazerDamage == "1S1K" and TargetDamage[TazerAmperage] == 0.85 and TazerInterval == "therapy" then
						CurrentPrisoner.Damage = 1
						this.TimesCharged = 10
						Set(CurrentPrisoner,"DeathType","Tortured")	
					elseif TazerDamage == "dieslow" then
						if CurrentPrisoner.Damage <= 0.9 then  										-- Some interesting stuff going with his health:
							CurrentPrisoner.Damage = CurrentPrisoner.Damage + TargetDamage[TazerAmperage]	-- He won't die when health is for example 0.9 + 0.10 (=1) ...
						else
							CurrentPrisoner.Damage = 1	
							Set(CurrentPrisoner,"DeathType","Tortured")											-- ...instead his health keeps below 0,9999999(9999...?) so we need to specify 1 manually to get him killed
						end
					elseif CurrentPrisoner.Damage <= 0.9 then
						CurrentPrisoner.Damage = CurrentPrisoner.Damage + TargetDamage[TazerAmperage]
					end
					AverageDamage = AverageDamage + CurrentPrisoner.Damage
				end
			end
			PrisonersToShock[CurrentPrisoner] = nil
			if Exists(MySweep) then
				MySweep.repeatCounter = 0
			end
			if Exists(MyBurst) then
				MyBurst.repeatCounter = 0
			end
			break
		end
	else
		DoTazerSweep = false
		this.SubType = AmpereAmount[TazerAmperage] + 10
	end
	
	if DoTazerSweep == false and ProcessedPrisoners > 0 then		-- Only discharge if a prisoner to be tazed was found. This keeps the battery from discharging with dead people around
		TotalDamage = 0
		if ProcessedPrisoners > 0 then
			TotalDamage = tostring(AverageDamage/ProcessedPrisoners)
		end
		DoTazerAdjust = true
		timeSweep = 0
		timePerSweepCheck = 1	-- add a little delay between zapping and adjusting the prisoners, otherwise they might not shake from a shock
	end
end

function DoAdjust()
	print("DoAdjust")
	timePerSweepCheck = 0.025	-- reset this delay back to normal once DoAdjust() has started
	if next(PrisonersToAdjust) then
		for CurrentPrisoner, dist in pairs(PrisonersToAdjust) do
			if CurrentPrisoner.beTazed == true then
				if TargetTazed[TazerAmperage] < 60 then
					CurrentPrisoner.StatusEffects.tazed = TargetTazed[TazerAmperage]	-- adjust with the demanded value (tazer below 60 wont make him shake).
				end

				for thatNeed, distance in pairs(CurrentPrisoner.Needs.NeedsMetaTable.GetterTable) do -- walk through a list of the prisoners available needs
					if thatNeed == "Alcohol" then CurrentPrisoner.Needs.Alcohol = 0 end
					if thatNeed == "Drugs" then CurrentPrisoner.Needs.Drugs = 0 end
				end
				
				CurrentPrisoner.Vel.x = 0
				CurrentPrisoner.Vel.y = 0
				CurrentPrisoner.StatusEffects.angst = 0
				CurrentPrisoner.Misbehavior = 0
				
				if this.DoCalm == true then CurrentPrisoner.StatusEffects.calming = 1000 end
				if this.DoBowels == true then CurrentPrisoner.Needs.Bowels = 100 end
				if this.DoBladder == true then CurrentPrisoner.Needs.Bladder = 100 end
				
				if CurrentPrisoner.Damage ~= 1 and this.DoSmoke == true and math.random() >= 0.75 then
					for s=1,SmokeAmount[TazerAmperage] do
						Object.Spawn("SmokeGenerator", CurrentPrisoner.Pos.x, CurrentPrisoner.Pos.y)
					end
				end
				
				CurrentPrisoner.beTazed = nil
			end
			PrisonersToAdjust[CurrentPrisoner] = nil
			if Exists(MySweep) then
				MySweep.repeatCounter = 0
			end
			if Exists(MyBurst) then
				MyBurst.repeatCounter = 0
			end
			break
		end
	else
		DoTazerAdjust = false
		this.SubType = AmpereAmount[TazerAmperage] + 10
		if this.PeakCreated == true then
			RemovePowerPeak()
		end
		if Exists(MySweep) then
			MySweep.repeatCounter = 11
		end
		if Exists(MyBurst) then
			MyBurst.repeatCounter = 11
		end
	end
end

-------------------------------------------------
-- Buttons

function AddButtons()
	Interface.AddComponent(this,"CaptionSeparator0", "Caption", "tooltip_T3separatorline")
	Interface.AddComponent(this,"CaptionTazeroptions", "Caption", "tooltip_T3TeslaOptions")
	Interface.AddComponent(this,"toggleAmperage", "Button", "tooltip_T3button_Amperage",TazerAmperage,"X")
	Interface.AddComponent(this,"toggleInterval", "Button", "tooltip_T3button_Interval",TazerInterval,"X")
	Interface.AddComponent(this,"CaptionSeparator1", "Caption", "tooltip_T3separatorline")
	Interface.AddComponent(this,"toggleTazerRangePlus", "Button", "tooltip_T3button_changerangeplus")
	Interface.AddComponent(this,"toggleShowCoveredTazerArea", "Button", "tooltip_T3button_ShowHideRange",TazerRange,"X")
	Interface.AddComponent(this,"toggleTazerRangeMinus", "Button", "tooltip_T3button_changerangeminus")
	Interface.AddComponent(this,"captionTargets","Caption","tooltip_T3caption_Who")
	Interface.AddComponent(this,"toggleWho", "Button", "tooltip_T3button_MisbehaviourOptions")
	Interface.AddComponent(this,"toggleIgnore", "Button", "tooltip_T3button_IgnoreOptions")
	Interface.AddComponent(this,"captionFX","Caption","tooltip_T3caption_SideEffects")
	Interface.AddComponent(this,"toggleBladder", "Button", "tooltip_T3button_BladderOptions")
	Interface.AddComponent(this,"toggleBowels", "Button", "tooltip_T3button_BowelsOptions")
	Interface.AddComponent(this,"toggleCalming", "Button", "tooltip_T3button_CalmingOptions")
	Interface.AddComponent(this,"toggleDamage", "Button", "tooltip_T3button_DamageOptions")
	Interface.AddComponent(this,"CaptionPerformance", "Caption", "tooltip_T3caption_Performance")
	Interface.AddComponent(this,"toggleEnergyBurst", "Button", "tooltip_T3button_PerformanceOptions")
	Interface.AddComponent(this,"togglePrisonerBurst", "Button", "tooltip_T3button_PerformanceOptions")
	Interface.AddComponent(this,"toggleSmoke", "Button", "tooltip_T3button_SmokeOptions")
	Interface.AddComponent(this,"toggleClearSmoke", "Button", "tooltip_T3button_ClearSmoke")
	Interface.AddComponent(this,"CaptionSeparator3", "Caption", "tooltip_T3separatorline")
	Interface.AddComponent(this,"toggleTazerNow", "Button", "tooltip_T3button_TazerNow")
end

function toggleTazerNowClicked()
	if Exists(MyDoorTimer) then
		if MyDoorTimer.On == true then
			if DoTazerSweep == false then
				PrepareSweep()
				DoTazerSweep = true
			end
		end
	else
		GetDoorTimer()
	end
end

function toggleAmperageClicked()
	if TazerAmperage=="low" then
		TazerAmperage="medium"
		newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
		Set(newPower,"HomeUID",this.HomeUID)
		Set(newPower,"Tooltip","Tesla-Matic Energy Source 2")
		newPower.Hidden = true
		if TazerInterval=="survey" then	-- survey mode only allows Low amperage
			TazerInterval="low"
			TazerTime = "tooltip_T3tazertime_low"
			TargetMinute = { [1]=3, [2]=8, [3]=13, [4]=18, [5]=23, [6]=28, [7]=33, [8]=38, [9]=43, [10]=48, [11]=53, [12]=58 }
			Set(this,"DoInterval",TazerInterval)
			this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
		end
	elseif TazerAmperage=="medium" then
		TazerAmperage="high"
		newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
		Set(newPower,"HomeUID",this.HomeUID)
		Set(newPower,"Tooltip","Tesla-Matic Energy Source 3")
		newPower.Hidden = true
	elseif TazerAmperage=="high" then
		TazerAmperage="ultra"
		newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
		Set(newPower,"HomeUID",this.HomeUID)
		Set(newPower,"Tooltip","Tesla-Matic Energy Source 4")
		newPower.Hidden = true
	elseif TazerAmperage=="ultra" then
		TazerAmperage="insane"
		newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
		Set(newPower,"HomeUID",this.HomeUID)
		Set(newPower,"Tooltip","Tesla-Matic Energy Source 5")
		newPower.Hidden = true
		if TazerInterval ~= "therapy" then
			TazerInterval = "therapy"
			Set(this,"DoInterval","therapy")
			TargetMinute = { [1]=25 }
			TazerTime = "tooltip_T3tazertime_therapy"
			this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
		end
		if TazerDamage ~= "1S1K" then
			TazerDamage = "1S1K"
			Set(this,"DoDeadly","1S1K")
			this.SetInterfaceCaption("toggleDamage", "tooltip_T3button_deadly_"..TazerDamage)
		end
	elseif TazerAmperage=="insane" then
		TazerAmperage="low"
		RemoveHighPower()		
		newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
		Set(newPower,"HomeUID",this.HomeUID)
		Set(newPower,"Tooltip","Tesla-Matic Energy Source 1")
		newPower.Hidden = true
		if TazerDamage == "1S1K" then
			TazerDamage = "off"
			Set(this,"DoDeadly","off")
			this.SetInterfaceCaption("toggleDamage", "tooltip_T3button_deadly_"..TazerDamage)
		end
	end
	
	UpdateCountDown()
	
	Set(this,"DoAmperage",TazerAmperage)
	this.SetInterfaceCaption("toggleAmperage", "tooltip_T3button_Amperage","tooltip_T3Amperage_"..tostring(TazerAmperage),"X")
	timePower = timePerPowerCheck
end

function toggleIntervalClicked()
	TargetMinute = {}
	if TazerInterval=="low" then
		TazerInterval="medium"
		TazerTime = "tooltip_T3tazertime_medium"
		TargetMinute = { [1]=2, [2]=17, [3]=32, [4]=47 }
	elseif TazerInterval=="medium" then
		TazerInterval="high"
		TazerTime = "tooltip_T3tazertime_high"
		TargetMinute = { [1]=23, [2]=53 }
	elseif TazerInterval=="high" then
		TazerInterval="therapy"
		TazerTime = "tooltip_T3tazertime_therapy"
		TargetMinute = { [1]=25 }
		if Get(this,"TazerAll") == false then
			Set(this,"TazerAll",true)
			this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerEverybody")
		end
		if Get(this,"Ignore") == true then
			Set(this,"Ignore",false)
			this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreNobody")
		end
	elseif TazerInterval=="therapy" then
		TazerInterval = "survey"
		if TazerAmperage ~= "low" then	-- survey mode only allows Low amperage
			TazerAmperage = "low"
			RemoveHighPower()	
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 1")
			newPower.Hidden = true
			Set(this,"DoAmperage","low")
			this.SetInterfaceCaption("toggleAmperage", "tooltip_T3button_Amperage","tooltip_T3Amperage_"..tostring(TazerAmperage),"X")
		end
		if TazerDamage ~= "off" then
			TazerDamage = "off"
			Set(this,"DoDeadly",TazerDamage)
			this.SetInterfaceCaption("toggleDamage", "tooltip_T3button_deadly_"..TazerDamage)
		end
		if Get(this,"TazerAll") == true then
			Set(this,"TazerAll",false)
			this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerMisbehaving")
		end
		if Get(this,"Ignore") == true then
			Set(this,"Ignore",false)
			this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreNobody")
		end
		TazerTime = "tooltip_T3tazertime_survey"
		TargetMinute = { [1]=9, [2]=19, [3]=29, [4]=39, [5]=49, [6]=59 }
	elseif TazerInterval=="survey" then
		TazerInterval="low"
		TazerTime = "tooltip_T3tazertime_low"
		TargetMinute = { [1]=3, [2]=8, [3]=13, [4]=18, [5]=23, [6]=28, [7]=33, [8]=38, [9]=43, [10]=48, [11]=53, [12]=58 }
	end
	
	UpdateCountDown()
	
	Set(this,"DoInterval",TazerInterval)
	this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
end

function toggleTazerRangePlusClicked()
	if TazerRange<=13 then
		TazerRange=TazerRange+2
		GetRangeXminYmax(TazerRange)
		Set(this,"DoRange",TazerRange)
		this.SetInterfaceCaption("toggleTazerRangePlus", "tooltip_T3button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredTazerArea", "tooltip_T3button_ShowHideRange",TazerRange,"X")
		this.SetInterfaceCaption("toggleTazerRangeMinus", "tooltip_T3button_changerangeminus")
		ShowCoveredArea(TazerRange,"Tazer")
	end
	UpdateCountDown()
end

function toggleTazerRangeMinusClicked()
	if TazerRange>=5 then
		TazerRange=TazerRange-2
		GetRangeXminYmax(TazerRange)
		Set(this,"DoRange",TazerRange)
		this.SetInterfaceCaption("toggleTazerRangePlus", "tooltip_T3button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredTazerArea", "tooltip_T3button_ShowHideRange",TazerRange,"X")
		this.SetInterfaceCaption("toggleTazerRangeMinus", "tooltip_T3button_changerangeminus")
		ShowCoveredArea(TazerRange,"Tazer")
	end
	UpdateCountDown()
end

function toggleShowCoveredTazerAreaClicked()
	ShowCoveredArea(TazerRange,"Tazer")
end

function toggleWhoClicked()
	if Get(this,"TazerAll")==true then
		Set(this,"TazerAll",false)
		this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerMisbehaving")
	else
		Set(this,"TazerAll",true)
		this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerEverybody")
		if TazerInterval=="survey" then	-- survey mode only allows scans for misbehaving prisoners
			TazerInterval="low"
			TazerTime = "tooltip_T3tazertime_low"
			TargetMinute = { [1]=3, [2]=8, [3]=13, [4]=18, [5]=23, [6]=28, [7]=33, [8]=38, [9]=43, [10]=48, [11]=53, [12]=58 }
			Set(this,"DoInterval",TazerInterval)
			this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
		end
	end
	UpdateCountDown()
end

function toggleIgnoreClicked()
	if Get(this,"Ignore")==true then
		Set(this,"Ignore",false)
		this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreNobody")
	else
		Set(this,"Ignore",true)
		this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreInjured")
	end
end

function toggleBladderClicked()
	if Get(this,"DoBladder")==true then
		Set(this,"DoBladder",false)
		this.SetInterfaceCaption("toggleBladder", "tooltip_T3button_BladderOff")
	else
		Set(this,"DoBladder",true)
		this.SetInterfaceCaption("toggleBladder", "tooltip_T3button_BladderOn")
	end
end

function toggleBowelsClicked()
	if Get(this,"DoBowels")==true then
		Set(this,"DoBowels",false)
		this.SetInterfaceCaption("toggleBowels", "tooltip_T3button_BowelsOff")
	else
		Set(this,"DoBowels",true)
		this.SetInterfaceCaption("toggleBowels", "tooltip_T3button_BowelsOn")
	end
end

function toggleDamageClicked()
	if TazerDamage=="off" then
		TazerDamage="notdeadly"
		if TazerInterval=="survey" then
			TazerInterval="low"
			TazerTime = "tooltip_T3tazertime_low"
			TargetMinute = { [1]=3, [2]=8, [3]=13, [4]=18, [5]=23, [6]=28, [7]=33, [8]=38, [9]=43, [10]=48, [11]=53, [12]=58 }
			Set(this,"DoInterval",TazerInterval)
			this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
		end
	elseif TazerDamage=="notdeadly" then
		TazerDamage="dieslow"
	elseif TazerDamage=="dieslow" then
		TazerDamage="1S1K"
		if TazerInterval ~= "therapy" then
			TazerInterval = "therapy"
			Set(this,"DoInterval","therapy")
			TargetMinute = { [1]=25 }
			TazerTime = "tooltip_T3tazertime_therapy"
			this.SetInterfaceCaption("toggleInterval", "tooltip_T3button_Interval","tooltip_T3Interval_"..tostring(TazerInterval),"X")
		end
		if TazerAmperage ~= "insane" then
			TazerAmperage = "insane"
			RemoveHighPower()	
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 1")
			newPower.Hidden = true
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 2")
			newPower.Hidden = true
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 3")
			newPower.Hidden = true
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 4")
			newPower.Hidden = true
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 5")
			newPower.Hidden = true
			Set(this,"DoAmperage","insane")
			this.SetInterfaceCaption("toggleAmperage", "tooltip_T3button_Amperage","tooltip_T3Amperage_"..tostring(TazerAmperage),"X")
		end
	elseif TazerDamage=="1S1K" then
		TazerDamage="off"
		if TazerAmperage == "insane" then
			TazerAmperage = "low"
			RemoveHighPower()	
			newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y-0.2)
			Set(newPower,"HomeUID",this.HomeUID)
			Set(newPower,"Tooltip","Tesla-Matic Energy Source 1")
			newPower.Hidden = true
			Set(this,"DoAmperage","low")
			this.SetInterfaceCaption("toggleAmperage", "tooltip_T3button_Amperage","tooltip_T3Amperage_"..tostring(TazerAmperage),"X")
		end
	end
	
	UpdateCountDown()
	
	Set(this,"DoDeadly",TazerDamage)
	this.SetInterfaceCaption("toggleDamage", "tooltip_T3button_deadly_"..TazerDamage)
end

function toggleCalmingClicked()
	if Get(this,"DoCalm")==true then
		Set(this,"DoCalm",false)
		this.SetInterfaceCaption("toggleCalming", "tooltip_T3button_CalmOff")
	else
		Set(this,"DoCalm",true)
		this.SetInterfaceCaption("toggleCalming", "tooltip_T3button_CalmOn")
	end
end

function toggleSmokeClicked()
	if Get(this,"DoSmoke")==true then
		Set(this,"DoSmoke",false)
		this.SetInterfaceCaption("toggleSmoke", "tooltip_T3button_SmokeOff")
	else
		Set(this,"DoSmoke",true)
		this.SetInterfaceCaption("toggleSmoke", "tooltip_T3button_SmokeOn")
	end
end

function toggleClearSmokeClicked()
	ClearSmoke()
end

function toggleEnergyBurstClicked()
	if Get(this,"DoEnergyBurst")==true then
		Set(this,"DoEnergyBurst",false)
		this.SetInterfaceCaption("toggleEnergyBurst", "tooltip_T3button_EnergyBurstOff")
	else
		Set(this,"DoEnergyBurst",true)
		this.SetInterfaceCaption("toggleEnergyBurst", "tooltip_T3button_EnergyBurstOn")
	end
end

function togglePrisonerBurstClicked()
	if Get(this,"DoPrisonerBurst")==true then
		Set(this,"DoPrisonerBurst",false)
		this.SetInterfaceCaption("togglePrisonerBurst", "tooltip_T3button_PrisonerBurstOff")
	else
		Set(this,"DoPrisonerBurst",true)
		this.SetInterfaceCaption("togglePrisonerBurst", "tooltip_T3button_PrisonerBurstOn")
	end
end

function ClearSmoke()
	local nearbySmoke = GetObjectsInSquare("SmokeGenerator",17)
	if next(nearbySmoke) then
		for thatSmoke,distance in pairs(nearbySmoke) do
			thatSmoke.Delete()
		end
	end
	nearbySmoke=nil
end

function ShowCoveredArea(theRange,theCoverType)
	GetRangeXminYmax(theRange)
	local n=0
	CoveredArea[theCoverType] = {}
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmin,i)
		Set(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Set(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_T3coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymin)
		Set(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Set(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_T3coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Ymin,Ymax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmax,i)
		Set(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Set(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_T3coveredarea",this.HomeUID,"X"}
		n=n+1
	end
	for i=Xmin,Xmax do
		CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymax)
		Set(CoveredArea[theCoverType][n],"HomeUID",this.HomeUID)
		Set(CoveredArea[theCoverType][n],"CoverType",theCoverType)
		CoveredArea[theCoverType][n].Tooltip={"tooltip_T3coveredarea",this.HomeUID,"X"}
		n=n+1
	end
end

-------------------------------------------------
-- Get stuff

function InitAfterSave()
	
	TazerInterval = Get(this,"DoInterval")
	if TazerInterval == "low" then	-- activate tazer at these minutes:
		TargetMinute = { [1]=3, [2]=8, [3]=13, [4]=18, [5]=23, [6]=28, [7]=33, [8]=38, [9]=43, [10]=48, [11]=53, [12]=58 }
		TazerTime = "tooltip_T3tazertime_low"
	elseif TazerInterval == "medium" then
		TargetMinute = { [1]=2, [2]=17, [3]=32, [4]=47 }
		TazerTime = "tooltip_T3tazertime_medium"
	elseif TazerInterval == "high" then
		TargetMinute = { [1]=23, [2]=53 }
		TazerTime = "tooltip_T3tazertime_high"
	elseif TazerInterval == "therapy" then
		TargetMinute = { [1]=25 }
		TazerTime = "tooltip_T3tazertime_therapy"
	elseif TazerInterval=="survey" then
		TargetMinute = { [1]=9, [2]=19, [3]=29, [4]=39, [5]=49, [6]=59 }
		TazerTime = "tooltip_T3tazertime_survey"
	end
	
	TazerRange=Get(this,"DoRange")
	TazerDamage = Get(this,"DoDeadly")
	TazerAmperage = Get(this,"DoAmperage")
	GetRangeXminYmax(TazerRange)
	
	if this.PeakCreated == true then
		RemovePowerPeak()
	end
		
	AddButtons()
	
	if Get(this,"TazerAll")==true then
		this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerEverybody")
	else
		this.SetInterfaceCaption("toggleWho", "tooltip_T3button_TazerMisbehaving")
	end
	if Get(this,"Ignore")==true then
		this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreInjured")
	else
		this.SetInterfaceCaption("toggleIgnore", "tooltip_T3button_IgnoreNobody")
	end
	if Get(this,"DoBladder")==true then
		this.SetInterfaceCaption("toggleBladder", "tooltip_T3button_BladderOn")
	else
		this.SetInterfaceCaption("toggleBladder", "tooltip_T3button_BladderOff")
	end
	if Get(this,"DoBowels")==true then
		this.SetInterfaceCaption("toggleBowels", "tooltip_T3button_BowelsOn")
	else
		this.SetInterfaceCaption("toggleBowels", "tooltip_T3button_BowelsOff")
	end
	this.SetInterfaceCaption("toggleDamage", "tooltip_T3button_deadly_"..TazerDamage)
	if Get(this,"DoCalm")==true then
		this.SetInterfaceCaption("toggleCalming", "tooltip_T3button_CalmOn")
	else
		this.SetInterfaceCaption("toggleCalming", "tooltip_T3button_CalmOff")
	end
	if Get(this,"DoSmoke")==true then
		this.SetInterfaceCaption("toggleSmoke", "tooltip_T3button_SmokeOn")
	else
		this.SetInterfaceCaption("toggleSmoke", "tooltip_T3button_SmokeOff")
	end
	if Get(this,"DoEnergyBurst")==true then
		this.SetInterfaceCaption("toggleEnergyBurst", "tooltip_T3button_EnergyBurstOn")
	else
		this.SetInterfaceCaption("toggleEnergyBurst", "tooltip_T3button_EnergyBurstOff")
	end
	if Get(this,"DoPrisonerBurst")==true then
		this.SetInterfaceCaption("togglePrisonerBurst", "tooltip_T3button_PrisonerBurstOn")
	else
		this.SetInterfaceCaption("togglePrisonerBurst", "tooltip_T3button_PrisonerBurstOff")
	end
	
	UpdateCountDown()
	
	timePower = timePerPowerCheck
end

function GetDoorTimer()
	local DoorTimerFound=false
	nearbyDoorTimers=Object.GetNearbyObjects(this,"DoorTimer",2)
	if next (nearbyDoorTimers) then
		for thatDoorTimer, distance in pairs (nearbyDoorTimers) do
			if thatDoorTimer.HomeUID == this.HomeUID then
				MyDoorTimer = thatDoorTimer
				DoorTimerFound=true
			end
		end
	end
	nearbyDoorTimers=nil
	
	if DoorTimerFound==true then
		Object.Sound("Tesla-Matic3","TeslaReady")
	else
		MyDoorTimer = Object.Spawn("DoorTimer", this.Pos.x+0.0065, this.Pos.y-0.215)
		Set(MyDoorTimer,"HomeUID",this.HomeUID)
		DoorTimerFound=true
	end
end

function RemoveHighPower()
	local nearbyMetalDetectors=Object.GetNearbyObjects(this,"MetalDetector",1)
	if next (nearbyMetalDetectors) then
		for thatMetalDetector, distance in pairs (nearbyMetalDetectors) do
			if thatMetalDetector.HomeUID == this.HomeUID then
				thatMetalDetector.Delete()
			end
		end
	end
	nearbyMetalDetectors = nil
end

function UpdateCountDown()
	if TazerInterval == "survey" then
		CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)	-- grab the game hour for the DoorTimer
		CurrentMinute = math.floor(math.mod(World.SecondsPlayed,60))	-- change the CurrentMinute value from Game minutes from the clock (in top right corner) into the Real-time seconds (from the Day button)
		timePerPowerCheck = 1												-- change the interval timer which we used for the other modes into the timer we need for Surveillance mode
	else
		CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)	-- grab the game hour for the DoorTimer
		CurrentMinute = math.floor(math.mod(World.TimeIndex,60))		-- change the CurrentMinute value from Real-time seconds (from the Day button) to Game minutes from the clock (in top right corner)
		timePerPowerCheck = 1 / World.TimeWarpFactor						-- change the interval timer which we used for Surveillance mode into the one for the other modes
	end
	
	NextMinute = 0
	TazerCountDown = 60 + TargetMinute[1] - CurrentMinute
	for i=1,#TargetMinute do
		if TargetMinute[i] > CurrentMinute then
			TazerCountDown = TargetMinute[i] - CurrentMinute
			NextMinute = TargetMinute[i]
			break
		end
	end
	
	if NextMinute == 0 then
		NextTime = CurrentHour + 1
		NextMinute = TargetMinute[1]
		TazerCountDown = (60 - CurrentMinute) + NextMinute
	else
		NextTime = CurrentHour
		TazerCountDown = NextMinute - CurrentMinute
	end
	
	if NextTime > 23 then NextTime = "00" elseif NextTime < 10 then NextTime = "0" .. tostring(NextTime) else NextTime = tostring(NextTime) end
	if NextMinute < 10 then
		NextTime = NextTime..":0"..tostring(NextMinute)
	else
		NextTime = NextTime..":"..tostring(NextMinute)
	end
	
	UpdateTooltip()
end

function UpdateTooltip()
	local Shock = "misbehaving    ||    "
	local Include = "nobody"
	local Mode = "---------------- TORTURE ----------------"
	if TazerInterval == "therapy" then Mode = "---------------- THERAPY ---------------"
	elseif TazerInterval == "survey" then Mode = "------------- SURVEILLANCE -------------" end
	if MyDoorTimer.On == false then Mode = "---------------- OFF-LINE ----------------" end
	if this.TazerAll == true then Shock = "everybody    ||    " end
	if this.Ignore == true then Include = "injured" end
	if MyDoorTimer.On == true then
		if Get(MyDoorTimer,"Time"..CurrentHour) == true then
			if DoTazerSweep == true then
				this.Tooltip = {"tooltip_T3TeslaTimerActive_SweepActive",Mode,"M",TazerRange,"A",Shock,"B",Include,"C",TazerTime,"D",TazerAmperage,"E",ProcessedPrisoners,"F",TotalDamage,"G"}
			
			else
				if TazerInterval == "survey" then
					this.Tooltip = {"tooltip_T3TeslaTimerActive_SurveyCountDown",Mode,"M",TazerRange,"A",Shock,"B",Include,"C",TazerTime,"D",TazerAmperage,"E",TazerCountDown,"F",ProcessedPrisoners,"G",TotalDamage,"H"}
				else
					this.Tooltip = {"tooltip_T3TeslaTimerActive_TazerCountDown",Mode,"M",TazerRange,"A",Shock,"B",Include,"C",TazerTime,"D",TazerAmperage,"E",TazerCountDown,"F",NextTime,"G",ProcessedPrisoners,"H",TotalDamage,"I"}
				end
			end
		else
			Mode = "Sleep - Tesla-Matic inactive"
			this.Tooltip={"tooltip_T3TeslaTimerInActive",Mode,"M",TazerRange,"A",Shock,"B",Include,"C",TazerTime,"D",TazerAmperage,"E"}
		end
	else
		this.Tooltip={"tooltip_T3TeslaNoPower",Mode,"M",TazerRange,"R"}
	end
end

function GetObjectsInSquare(theObject,theRange) -- returns targetobjects in a square around the object
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function GetRangeXminYmax(RangeToGet)
	Xmin=math.ceil(this.Pos.x-RangeToGet/2)
	Xmax=math.ceil(this.Pos.x+RangeToGet/2)
	Ymin=math.ceil(this.Pos.y-RangeToGet/2)
	Ymax=math.ceil(this.Pos.y+RangeToGet/2)
end	

function CreatePowerPeak()
	for p=1,AmpereAmount[TazerAmperage] do
		local newPower = Object.Spawn("MetalDetector", this.Pos.x, this.Pos.y)
		newPower.HomeUID = this.HomeUID
		newPower.IsPeak = true
		newPower.Tooltip = "Tesla-Matic Energy Peak "..p
		newPower.Hidden = true
	end
end

function RemovePowerPeak()
	local nearbyMetalDetectors=Object.GetNearbyObjects(this,"MetalDetector",1)
	if next (nearbyMetalDetectors) then
		for thatMetalDetector, distance in pairs (nearbyMetalDetectors) do
			if thatMetalDetector.HomeUID == this.HomeUID and thatMetalDetector.IsPeak == true then
				thatMetalDetector.Delete()
			end
		end
	end
	nearbyMetalDetectors = nil
	this.PeakCreated = nil
end

function DoOverload()
	RemoveHighPower()
	local ExplodedTeslaMatic3 = Object.Spawn("ExplodedTeslaMatic3",this.Pos.x,this.Pos.y)
	Set(ExplodedTeslaMatic3,"Damage",1)
	Set(ExplodedTeslaMatic3,"Tooltip","tooltip_T3TeslaOverload")
	ExplodedTeslaMatic3.Sound("__RiotAssault", "Explosion")
	local velX = -1.0 + math.random() + math.random()
	local velY = -1.0 + math.random() + math.random()
	Object.ApplyVelocity(ExplodedTeslaMatic3, velX, velY)
	for s=1,SmokeAmount[TazerAmperage] do
		local Fire = Object.Spawn("Fire", ExplodedTeslaMatic3.Pos.x-1+math.random()+math.random(), ExplodedTeslaMatic3.Pos.y-1+math.random()+math.random())
		Fire.Fuel = 0.7
		Fire.Intensity = 1.0
	end
	if Exists(MyDoorTimer) then MyDoorTimer.Delete() end
	this.Delete()
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
